## GPermission

GPermission — An object representing the permission to perform a certain action

## Functions

gboolean | g_permission_get_allowed ()
gboolean | g_permission_get_can_acquire ()
gboolean | g_permission_get_can_release ()
gboolean | g_permission_acquire ()
void | g_permission_acquire_async ()
gboolean | g_permission_acquire_finish ()
gboolean | g_permission_release ()
void | g_permission_release_async ()
gboolean | g_permission_release_finish ()
void | g_permission_impl_update ()

## Properties

gboolean | allowed | Read
gboolean | can-acquire | Read
gboolean | can-release | Read

## Types and Values

| GPermission

## Object Hierarchy

        GObject
        ╰── GPermission
            ╰── GSimplePermission

## Includes

    #include <gio/gio.h>

## Description

A GPermission represents the status of the caller's permission to perform a certain action.

You can query if the action is currently allowed and if it is possible to acquire the permission so that the action will be allowed in the future.

There is also an API to actually acquire the permission and one to release it.

As an example, a GPermission might represent the ability for the user to write to a GSettings object. This GPermission object could then be used to decide if it is appropriate to show a "Click here to unlock" button in a dialog and to provide the mechanism to invoke when that button is clicked.

## Functions

### g_permission_get_allowed ()

    gboolean
    g_permission_get_allowed (GPermission *permission);

Gets the value of the 'allowed' property. This property is `TRUE` if the caller currently has permission to perform the action that `permission` represents the permission to perform.

#### Parameters

permission | a GPermission instance |

#### Returns

the value of the 'allowed' property

Since: 2.26

### g_permission_get_can_acquire ()

    gboolean
    g_permission_get_can_acquire (GPermission *permission);

Gets the value of the 'can-acquire' property. This property is `TRUE` if it is generally possible to acquire the permission by calling `g_permission_acquire()`.

#### Parameters

permission | a GPermission instance |

#### Returns

the value of the 'can-acquire' property

Since: 2.26

### g_permission_get_can_release ()

    gboolean
    g_permission_get_can_release (GPermission *permission);

Gets the value of the 'can-release' property. This property is `TRUE` if it is generally possible to release the permission by calling `g_permission_release()`.

#### Parameters

permission | a GPermission instance |

#### Returns

the value of the 'can-release' property

Since: 2.26

### g_permission_acquire ()

    gboolean
    g_permission_acquire (GPermission *permission,
                          GCancellable *cancellable,
                          GError **error);

Attempts to acquire the permission represented by `permission` .

The precise method by which this happens depends on the permission and the underlying authentication mechanism. A simple example is that a dialog may appear asking the user to enter their password.

You should check with `g_permission_get_can_acquire()` before calling this function.

If the permission is acquired then `TRUE` is returned. Otherwise, `FALSE` is returned and `error` is set appropriately.

This call is blocking, likely for a very long time (in the case that user interaction is required). See `g_permission_acquire_async()` for the non-blocking version.

#### Parameters

permission | a GPermission instance |
cancellable | a GCancellable, or `NULL`. | [nullable]
error | a pointer to a `NULL` GError, or `NULL` |

#### Returns

`TRUE` if the permission was successfully acquired

Since: 2.26

### g_permission_acquire_async ()

    void
    g_permission_acquire_async (GPermission *permission,
                                GCancellable *cancellable,
                                GAsyncReadyCallback callback,
                                gpointer user_data);

Attempts to acquire the permission represented by `permission` .

This is the first half of the asynchronous version of `g_permission_acquire()`.

#### Parameters

permission | a GPermission instance |
cancellable | a GCancellable, or `NULL`. | [nullable]
callback | the GAsyncReadyCallback to call when done |
user_data | the user data to pass to `callback` |

Since: 2.26

### g_permission_acquire_finish ()

    gboolean
    g_permission_acquire_finish (GPermission *permission,
                                 GAsyncResult *result,
                                 GError **error);

Collects the result of attempting to acquire the permission represented by `permission` .

This is the second half of the asynchronous version of `g_permission_acquire()`.

#### Parameters

permission | a GPermission instance |
result | the GAsyncResult given to the GAsyncReadyCallback |
error | a pointer to a `NULL` GError, or `NULL` |

#### Returns

`TRUE` if the permission was successfully acquired

Since: 2.26

### g_permission_release ()

    gboolean
    g_permission_release (GPermission *permission,
                          GCancellable *cancellable,
                          GError **error);

Attempts to release the permission represented by `permission` .

The precise method by which this happens depends on the permission and the underlying authentication mechanism. In most cases the permission will be dropped immediately without further action.

You should check with `g_permission_get_can_release()` before calling this function.

If the permission is released then `TRUE` is returned. Otherwise, `FALSE` is returned and `error` is set appropriately.

This call is blocking, likely for a very long time (in the case that user interaction is required). See `g_permission_release_async()` for the non-blocking version.

#### Parameters

permission | a GPermission instance |
cancellable | a GCancellable, or `NULL`. | [nullable]
error | a pointer to a `NULL` GError, or `NULL` |

#### Returns

`TRUE` if the permission was successfully released

Since: 2.26

### g_permission_release_async ()

    void
    g_permission_release_async (GPermission *permission,
                                GCancellable *cancellable,
                                GAsyncReadyCallback callback,
                                gpointer user_data);

Attempts to release the permission represented by `permission` .

This is the first half of the asynchronous version of `g_permission_release()`.

#### Parameters

permission | a GPermission instance |
cancellable | a GCancellable, or `NULL`. | [nullable]
callback | the GAsyncReadyCallback to call when done |
user_data | the user data to pass to `callback` |

Since: 2.26

### g_permission_release_finish ()

    gboolean
    g_permission_release_finish (GPermission *permission,
                                 GAsyncResult *result,
                                 GError **error);

Collects the result of attempting to release the permission represented by `permission` .

This is the second half of the asynchronous version of `g_permission_release()`.

#### Parameters

permission | a GPermission instance |
result | the GAsyncResult given to the GAsyncReadyCallback |
error | a pointer to a `NULL` GError, or `NULL` |

#### Returns

`TRUE` if the permission was successfully released

Since: 2.26

### g_permission_impl_update ()

    void
    g_permission_impl_update (GPermission *permission,
                              gboolean allowed,
                              gboolean can_acquire,
                              gboolean can_release);

This function is called by the GPermission implementation to update the properties of the permission. You should never call this function except from a GPermission implementation.

GObject notify signals are generated, as appropriate.

#### Parameters

permission | a GPermission instance |
allowed | the new value for the 'allowed' property |
can_acquire | the new value for the 'can-acquire' property |
can_release | the new value for the 'can-release' property |

Since: 2.26

## Types and Values

### GPermission

    typedef struct _GPermission GPermission;

GPermission is an opaque data structure and can only be accessed using the following functions.

## Property Details

### The `“allowed”` property

      “allowed”                  gboolean

`TRUE` if the caller currently has permission to perform the action that `permission` represents the permission to perform.

Flags: Read

Default value: FALSE

### The `“can-acquire”` property

      “can-acquire”              gboolean

`TRUE` if it is generally possible to acquire the permission by calling `g_permission_acquire()`.

Flags: Read

Default value: FALSE

### The `“can-release”` property

      “can-release”              gboolean

`TRUE` if it is generally possible to release the permission by calling `g_permission_release()`.

Flags: Read

Default value: FALSE